
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Bom_headersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bom_headers = await db.bom_headers.create(
            {
                id: data.id || undefined,
        
        bom_code: data.bom_code
        ||
        null
            ,
            
        revision: data.revision
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        effective_from: data.effective_from
        ||
        null
            ,
            
        effective_to: data.effective_to
        ||
        null
            ,
            
        yield_quantity: data.yield_quantity
        ||
        null
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        approved_at: data.approved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await bom_headers.setItem( data.item || null, {
            transaction,
        });
        
        await bom_headers.setApproved_by( data.approved_by || null, {
            transaction,
        });
        

        

        

        return bom_headers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const bom_headersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                bom_code: item.bom_code
            ||
            null
            ,
            
                revision: item.revision
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                effective_from: item.effective_from
            ||
            null
            ,
            
                effective_to: item.effective_to
            ||
            null
            ,
            
                yield_quantity: item.yield_quantity
            ||
            null
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                approved_at: item.approved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const bom_headers = await db.bom_headers.bulkCreate(bom_headersData, { transaction });

        // For each item created, replace relation files
        

        return bom_headers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const bom_headers = await db.bom_headers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.bom_code !== undefined) updatePayload.bom_code = data.bom_code;
        
        
        if (data.revision !== undefined) updatePayload.revision = data.revision;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.effective_from !== undefined) updatePayload.effective_from = data.effective_from;
        
        
        if (data.effective_to !== undefined) updatePayload.effective_to = data.effective_to;
        
        
        if (data.yield_quantity !== undefined) updatePayload.yield_quantity = data.yield_quantity;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.approved_at !== undefined) updatePayload.approved_at = data.approved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await bom_headers.update(updatePayload, {transaction});

        
        
        if (data.item !== undefined) {
            await bom_headers.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.approved_by !== undefined) {
            await bom_headers.setApproved_by(
              
              data.approved_by,
              
              { transaction }
            );
        }
        

        
        

        

        return bom_headers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bom_headers = await db.bom_headers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of bom_headers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of bom_headers) {
                await record.destroy({transaction});
            }
        });


        return bom_headers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const bom_headers = await db.bom_headers.findByPk(id, options);

        await bom_headers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await bom_headers.destroy({
            transaction
        });

        return bom_headers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const bom_headers = await db.bom_headers.findOne(
            { where },
            { transaction },
        );

        if (!bom_headers) {
            return bom_headers;
        }

        const output = bom_headers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.bom_lines_bom_header = await bom_headers.getBom_lines_bom_header({
            transaction
        });
        
        
        
        
        
        
        output.production_orders_bom = await bom_headers.getProduction_orders_bom({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.item = await bom_headers.getItem({
            transaction
        });
        
        
        output.approved_by = await bom_headers.getApproved_by({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'approved_by',
        
        where: filter.approved_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approved_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approved_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.bom_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bom_headers',
                        'bom_code',
                        filter.bom_code,
                    ),
                };
            }
            
            if (filter.revision) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bom_headers',
                        'revision',
                        filter.revision,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bom_headers',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            effective_from: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    effective_to: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.effective_fromRange) {
                const [start, end] = filter.effective_fromRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_from: {
                    ...where.effective_from,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_from: {
                    ...where.effective_from,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.effective_toRange) {
                const [start, end] = filter.effective_toRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_to: {
                    ...where.effective_to,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_to: {
                    ...where.effective_to,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.yield_quantityRange) {
                const [start, end] = filter.yield_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    yield_quantity: {
                    ...where.yield_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    yield_quantity: {
                    ...where.yield_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.approved_atRange) {
                const [start, end] = filter.approved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.bom_headers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'bom_headers',
                        'bom_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.bom_headers.findAll({
            attributes: [ 'id', 'bom_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['bom_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.bom_code,
        }));
    }

    
};

